<template>
  <div class="bg-[#fff]">
    <a-page-header style="border: 1px solid rgb(235, 237, 240)" @back="router.go(-1)">
      <template #backIcon>
        <div><a-button type="primary">返回</a-button></div>
      </template>
      <template #title>
        <div></div>
      </template>
    </a-page-header>
    <a-collapse v-model:activeKey="activeKey" :bordered="false">
      <a-collapse-panel key="1" header="地块信息" :forceRender="true">
        <DkTable :data="dsInfor.wrdkjbxxb" />
      </a-collapse-panel>

      <a-collapse-panel key="2" header="管控及修复方案基本信息" :forceRender="true">
        <suBainForm ref="chilrenReport" labelFirst="管控及修复" :jslx="dsInfor?.gkxf?.jslx || ''" :data="dsInfor?.gkxf" />
        <template #extra><a-button type="primary" @click.prevent="saveReport($event)">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel key="3" header="污染土壤外运处置" :forceRender="true">
        <sftrwy ref="chilrenwrtrwy" :data="{ sfczwrtrwycz: isres, wrdkid: params.wrdkid }" />
        <template #extra><a-button type="primary" @click.prevent="saveWrtr($event)">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复方案编制单位基本信息" :forceRender="true" v-for="(item, index) in unitMessageFormList" :key="index + 4">
        <unitMessageForm :ref="(el) => childRef(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addUnitMessageFormList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="delMessageFormList($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="suBainFormAddEdit($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复方案实施单位基本信息" :forceRender="true" v-for="(item, index) in ssdw" :key="index + 9">
        <unitMessageForm :ref="(el) => childRefss(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addSs($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deless($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="savess($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel
        header="管控及修复方案监理单位基本信息"
        :forceRender="true"
        v-for="(item, index) in jldw"
        :key="index + 12"
        :dkxx="{ wrdkid: dsInfor.wrdkjbxxb.wrdkid, scjdbm: 'S5' }"
      >
        <unitMessageForm :ref="(el) => childRefjl(el, index)" :data="item" upload="检测单位" title="监理" />
        <template #extra>
          <a-button type="primary" @click.prevent="addjl($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deljl($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="savejl($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel key="4222222" header="土壤和地下水管控及修复信息">
          <EditTrwrDetail  :data="dsInfor.trhjfxxx" />
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复措施信息" :forceRender="true" key="140000">
        <ControlInformationgkxf
          labelFirst="修复"
          ref="chilrenXfcs"
          :obj="[{ name: '开展修复土壤面积(m²)' }, { name: '修复土壤方量(m³)' }]"
          :data="dsInfor.gkxf"
        />
        <template #extra><a-button type="primary" @click.prevent="saveXfcs($event)">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复文件上传" :forceRender="true" key="150000">
        <CdUpload
          labelFirst="管控与修复"
          :objec="[{ name: '公示截图' }, { name: '管控及修复报告' }]"
          :data="{ ...dsInfor.gkxf, scjdbm: 'S10', pgtype: params.pgtype }"
        />
      </a-collapse-panel>
      <a-collapse-panel header="填报进度" :forceRender="true" key="160000">
        <Progress />
      </a-collapse-panel>
    </a-collapse>
  </div>
</template>
<script lang="ts" setup>
  import { ref } from 'vue';
  import DkTable from '/@/components/customComponent/DkTable.vue';
  import suBainForm from '/@/components/customComponent/fxgk/ControlPlan.vue';
  // import ControlInformation from '/@/components/customComponent/gkpg/csInfor.vue';
  import ControlInformationgkxf from '/@/components/customComponent/gkpg/ControlInformationgkxf.vue';
  import EditTrwrDetail from '/@/components/customComponent/fxpg/trfxDetail.vue'; //土壤和地下水管控及修复信息
  import unitMessageForm from '/@/components/customComponent/unitMessageForm.vue';
  import Progress from '/@/components/customComponent/fillProgress.vue';
  import CdUpload from '/@/components/customComponent/CdUpload.vue';
  import sftrwy from '/@/components/customComponent/sftrwy.vue';
  import { Modal } from 'ant-design-vue';
  import { plotDetails, updateBzdw, delBzdw, saveGkxf, updateJcdw, delJcdw, updateSfczwrtrwycz, isSfczwrtrwycz } from '/@/api/common/api';
  import { useRouter } from 'vue-router';
  import { nextTick } from 'vue';
  import { useMessage } from '@/hooks/web/useMessage';

  let router = useRouter();
  const saveFlg = ref(true);
  const { createMessage } = useMessage();
  const params = ref(router.currentRoute.value.query);
  let unitMessageFormList = ref([{ id: null }]);
  const ssdw = ref([{ id: null }]);
  const jldw = ref([{ id: null }]);
  const isres = ref('');
  // 获取地块信息
  const dsInfor = ref<any>({
    ssdw: [],
    jldw: [],
    jcdw: [],
    bzdw: [],
    cbdc: {},
    xxdc: {},
    wrdkjbxxb: {},
  });

  async function getdkInfor() {
    dsInfor.value = await plotDetails({
      wrdkid: params.value.wrdkid,
      id: params.value.id,
      pgtype: params.value.pgtype,
      scjdbm: 'S10',
    });
    isres.value = await isSfczwrtrwycz({ wrdkid: params.value.wrdkid });
    saveFlg.value = true;
    unitMessageFormList.value = dsInfor.value.bzdw || [{ id: null }];
    ssdw.value = dsInfor.value.ssdw || [{ id: null }];
    jldw.value = dsInfor.value.jldw || [{ id: null }];

    if (unitMessageFormList.value.length == 0) unitMessageFormList.value.push({ id: null });
    if (ssdw.value.length == 0) ssdw.value.push({ id: null });
    if (jldw.value.length == 0) jldw.value.push({ id: null });
  }
  getdkInfor();

  const activeKey = ref(['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '140000', '150000', '160000', '4222222']);

  // 风险管控基本方案
  const chilrenReport = ref<any>(null);
  async function saveReport(event) {
    event.stopPropagation();
    const res = await chilrenReport?.value.getFormValueReport();
    res.pgtype = params.value.pgtype;
    const reg = /^(http|https):\/\/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|localhost|[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.[a-zA-Z]{2,})(:\d{2,5})?(\/\S*)?$/
    if (res.gsfs == 1) {
      if (!res.gswz) {
        createMessage.warn('请填写网址');
        return;
      }
      if (!reg.test(res.gswz)) {
        createMessage.warn('请输入正确的网址');
        return false;
      }
    }
    if (new Date(res.tmStart) > new Date(res.tmEnd)) {
      createMessage.warn('管控及修复工程措施开始日期不能大于管控及修复工程措施结束日期');
      return;
    }
    // if (new Date(res.fbsj) > new Date(res.tmStart)) {
    //   createMessage.warn('管控及修复方案编制完成日期不能大于管控及修复工程措施开始日期');
    //   return;
    // }

    await saveGkxf(res);
  }
  // 污染土壤外运保存
  const chilrenwrtrwy = ref<any>(null);
  async function saveWrtr(event) {
    event.stopPropagation();
    const res = await chilrenwrtrwy?.value.getFormValue();
    isres.value = await isSfczwrtrwycz({ wrdkid: params.value.wrdkid });
    console.log(res.sfczwrtrwycz != isres.value && res.sfczwrtrwycz === 0, 'isres');
    console.log(res.sfczwrtrwycz, isres.value, 'isres');
    if (isres.value !== null) {
      if (res.sfczwrtrwycz != isres.value && res.sfczwrtrwycz === 0) {
        Modal.confirm({
          title: '确认',
          content: '已有方案内存在【污染土壤外运】情况，如变更状态则会清空【污染土壤外运】已填报信息，请确认！',
          centered: true,
          okText: '确认',
          cancelText: '取消',
          onOk: async () => {
            await updateSfczwrtrwycz(res);
            isres.value = await isSfczwrtrwycz({ wrdkid: params.value.wrdkid });
          },
        });
      } else {
        await updateSfczwrtrwycz(res);
        isres.value = await isSfczwrtrwycz({ wrdkid: params.value.wrdkid });
      }
    } else {
      await updateSfczwrtrwycz(res);
      isres.value = await isSfczwrtrwycz({ wrdkid: params.value.wrdkid });
    }
  }
  //风险管控措施
  const chilrenXfcs = ref<any>(null);
  async function saveXfcs(event) {
    event.stopPropagation();
    const res = await chilrenXfcs?.value.getFormValueFxpg();
    res.pgtype = params.value.pgtype;
    if (res.kzfxgktrmj > dsInfor.value.wrdkjbxxb.zdmj) {
      createMessage.warn('开展修复土壤面积不能超过地块占地面积');
      return false;
    }
    if (res.gkcs == 2) {
      if (res.checkboxInputValue) {
        res.gkcsQt = res.checkboxValue + ',' + res.checkboxInputValue;
      } else {
        res.gkcsQt = res.checkboxValue;
      }
    }
    await saveGkxf(res);
  }
  // 编制单位开始
  const childrenBzd = ref<any>([]);
  const childRef = (el, index) => {
    if (el) childrenBzd.value[index] = el;
  };
  const callChildMethod = (index) => {
    childrenBzd.value[index].getFormValueBz();
  };
  function addUnitMessageFormList(event) {
    event.stopPropagation();
    unitMessageFormList.value.push({ id: null });
    nextTick(() => {
      callChildMethod(unitMessageFormList.value.length - 1);
    });
  }
  async function delMessageFormList(event, index) {
    event.stopPropagation();
    if (unitMessageFormList.value[index].id) {
      await delBzdw({ id: unitMessageFormList.value[index].id });
    }
    unitMessageFormList.value.splice(index, 1);
    childrenBzd.value.splice(index, 1);
    // getdkInfor();
  }
  async function suBainFormAddEdit(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenBzd.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.pgtype = params.value.pgtype;
        res.scjdbm = 'S10';
        res.jgtype = 'bzdw';
        // 新增的时候没有这个值
        res.wrdkid = params.value.wrdkid;
        const id = await updateBzdw(res);
        if (id != '成功') {
          unitMessageFormList.value[index] = res;
          unitMessageFormList.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  // 编制单位结束
  // 实施单位
  const childrenss = ref<any>([]);
  const childRefss = (el, index) => {
    if (el) childrenss.value[index] = el;
  };
  const callChildMethodss = (index) => {
    childrenss.value[index].getFormValueBz();
  };
  // 新增
  function addSs(event) {
    event.stopPropagation();
    ssdw.value.push({ id: null });
    nextTick(() => {
      callChildMethodss(ssdw.value.length - 1);
    });
  }
  // 删除
  async function deless(event, index) {
    event.stopPropagation();
    if (ssdw.value[index].id) await delBzdw({ id: ssdw.value[index].id });
    ssdw.value.splice(index, 1);
    childrenss.value.splice(index, 1);
  }
  // 保存
  async function savess(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenss.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S10';
        res.pgtype = params.value.pgtype;
        res.jgtype = 'ssdw';
        res.wrdkid = params.value.wrdkid;
        const id = await updateBzdw(res);
        if (id != '成功') {
          ssdw.value[index] = res;
          ssdw.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  //监理单位
  const childrenjl = ref<any>([]);
  const childRefjl = (el, index) => {
    if (el) childrenjl.value[index] = el;
  };
  const callChildMethodjl = (index) => {
    childrenss.value[index].getFormValueBz();
  };
  // 新增
  function addjl(event) {
    event.stopPropagation();
    jldw.value.push({ id: null });
    nextTick(() => {
      callChildMethodjl(jldw.value.length - 1);
    });
  }
  // 删除
  async function deljl(event, index) {
    event.stopPropagation();
    if (jldw.value[index].id) await delJcdw({ id: jldw.value[index].id });
    jldw.value.splice(index, 1);
    childrenjl.value.splice(index, 1);
  }
  // 保存
  async function savejl(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenjl.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S10';
        res.pgtype = params.value.pgtype;
        res.jgtype = 'jldw';
        res.wrdkid = params.value.wrdkid;
        const id = await updateJcdw(res);
        if (id != '成功') {
          jldw.value[index] = res;
          jldw.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
</script>

<style lang="less" scoped>
  :deep(.ant-collapse-borderless) {
    width: 100%;
  }
</style>
